import { ObjectUIServiceBase } from '@objects-view/object-ui-service-base';
import { IUserGroupModel } from '@fleio-api/client-user/model/user-group.model';
import { Router } from '@angular/router';
import { ConfigService } from '@shared/config/config.service';
import { UserGroupsApiService } from '@fleio-api/client-user/user-group/user-groups-api.service';
import { DateFormatterPipe } from '@shared/ui/common/pipes/date-formatter.pipe';
import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IIcon } from '@shared/ui/common/interfaces/icon';
import { IObjectStatus } from '@objects-view/interfaces/object-status';
import { ITitle } from '@objects-view/interfaces/card-data/card-title';
import { IAction } from '@objects-view/interfaces/actions/action';
import { RouterLinkAction } from '@objects-view/actions/router-link-action';
import { ApiCallAction, CallType } from '@objects-view/actions/api-call-action';
import { CallbackAction } from '@objects-view/actions/callback-action';
import { IDataField } from '@objects-view/interfaces/card-data/data-field';
import { IDetailsTab } from '@objects-view/interfaces/details/details-tab';
import { UserGroupEditFormComponent } from './tabs/user-group-edit-form/user-group-edit-form.component';
import {
  UserGroupDetailsOverviewComponent
} from './tabs/user-group-details-overview/user-group-details-overview.component';
import { AuthService } from '@shared/auth/auth.service';
import {
  UserGroupDetailsPermissionsComponent
} from './tabs/user-group-details-permissions/user-group-details-permissions.component';

export class UserGroupUiService extends ObjectUIServiceBase<IUserGroupModel> {
  private readonly datePipe: DateFormatterPipe;

  constructor(
    userGroup: IUserGroupModel, permissions: IPermissionsModel, state: string,
    private readonly router: Router,
    private readonly config: ConfigService,
    private readonly userGroupsApiService: UserGroupsApiService,
    private auth: AuthService,
  ) {
    super(userGroup, permissions, state);
    this.router = router;
    this.config = config;
    this.userGroupsApiService = userGroupsApiService;
    this.datePipe = new DateFormatterPipe(this.config);
  }

  getIcon(): IIcon {
    return null;
  }

  getStatus(): IObjectStatus {
    return null;
  }

  getTitle(): ITitle {
    switch (this.state) {
      case 'edit':
        return {
          text: $localize`Edit user group ${this.object.name}`,
        };

      case 'create':
        return {
          text: $localize`Create new user group`,
        };

      case 'details':
        return {
          text: `${this.object.name}`,
          subText: $localize`Created at: ${this.datePipe.transform(this.object.created_at)}`,
        };

      default:
        return {
          text: `${this.object.name}`,
        };
    }
  }

  getActions(): IAction[] {
    const actions: IAction[] = [];

    actions.push(new RouterLinkAction({
        icon: {name: 'edit', class: 'fl-icons'},
        name: $localize`Edit`,
        tooltip: $localize`Edit user group`,
        routerUrl: this.config.getPanelUrl(`clients-users/user-groups/${this.object.id}/edit`),
        router: this.router,
      }
    ));

    const deleteAction = new ApiCallAction(
      {
        object: this.object,
        icon: {name: 'delete'},
        tooltip: $localize`Delete user group`,
        name: $localize`Delete`,
        confirmOptions: {
          confirm: true,
          title: $localize`Delete user group`,
          message: $localize`Are you sure you want to delete user group ${this.object.name}?`,
        },
        successMessage: $localize`User group deleted`,
        errorMessage: $localize`Failed to delete user group, check logs for details`,
        apiService: this.userGroupsApiService,
        callType: CallType.Delete,
        refreshAfterExecute: false,
        redirectAfterExecute: true,
        redirectUrl: this.config.getPanelUrl('clients-users/user-groups'),
      }
    );

    actions.push(deleteAction);

    return actions;
  }

  getDetailsActions(): IAction[] {
    const actions = [];

    switch (this.state) {
      case 'create':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`clients-users/user-groups`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Create`}));
        break;
      case 'edit':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`clients-users/user-groups`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Save`}));
        break;
      default:
        break;
    }

    return actions;
  }

  getDetailsLink(): string {
    return this.config.getPanelUrl(`clients-users/user-groups/${this.object.id}`);
  }

  getCardFields(): IDataField[] {
    const fields = [
      {value: $localize`${this.object.users_count} users in this group`},
      {name: $localize`Permissions`, value: this.object.permissions ? $localize`custom` : $localize`default`},
      {
        name: $localize`Created at`,
        value: this.datePipe.transform(this.object.created_at),
        title: this.datePipe.getTitleAttributeValue(this.object.created_at),
      },
    ];

    return fields;
  }

  getTabs(): IDetailsTab[] {
    switch (this.state) {
      case 'create':
        return [
          {
            tabName: $localize`Create`,
            tabIdentifier: 'create',
            component: UserGroupEditFormComponent,
          },
        ];
      case 'edit':
        return [
          {
            tabName: $localize`Edit`,
            tabIdentifier: 'edit',
            component: UserGroupEditFormComponent,
          },
        ];
      case 'details':
        const tabs = [
          {
            tabName: $localize`Overview`,
            tabIdentifier: 'overview',
            component: UserGroupDetailsOverviewComponent,
          },
        ] as IDetailsTab[];
        if (this.auth.userData.user.is_superuser) {
          tabs.push({
            tabName: $localize`Permissions`,
            tabIdentifier: 'permissions',
            component: UserGroupDetailsPermissionsComponent,
          });
        }
        return tabs;
    }
  }

  getCardTags(): string[] {
    const tags = [];
    return tags;
  }
}
